# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from robotont_msgs/PowerSupply.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PowerSupply(genpy.Message):
  _md5sum = "77b9b8496ff236da784fb46719fa61bb"
  _type = "robotont_msgs/PowerSupply"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Measured current consumption 
float32 current

# Measured voltage level of the battery
float32 voltage

# Indicates whether e-stop button is pressed or not
bool estop_pressed"""
  __slots__ = ['current','voltage','estop_pressed']
  _slot_types = ['float32','float32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       current,voltage,estop_pressed

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PowerSupply, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.current is None:
        self.current = 0.
      if self.voltage is None:
        self.voltage = 0.
      if self.estop_pressed is None:
        self.estop_pressed = False
    else:
      self.current = 0.
      self.voltage = 0.
      self.estop_pressed = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2fB().pack(_x.current, _x.voltage, _x.estop_pressed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.current, _x.voltage, _x.estop_pressed,) = _get_struct_2fB().unpack(str[start:end])
      self.estop_pressed = bool(self.estop_pressed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2fB().pack(_x.current, _x.voltage, _x.estop_pressed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 9
      (_x.current, _x.voltage, _x.estop_pressed,) = _get_struct_2fB().unpack(str[start:end])
      self.estop_pressed = bool(self.estop_pressed)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2fB = None
def _get_struct_2fB():
    global _struct_2fB
    if _struct_2fB is None:
        _struct_2fB = struct.Struct("<2fB")
    return _struct_2fB
